part of forestvpn_api.api;

class AppleStoreUnifiedReceipt {
  /* The environment for which the receipt was generated. */
  String environment = null;
  //enum environmentEnum {  Sandbox,  Production,  };
/* The latest Base64-encoded app receipt. */
  String latestReceipt = null;
  
/* The JSON representation of the value in latest_receipt. Note that this field is an array in the receipt but a single object in server-to-server notifications. */
  List<AppleStoreLatestReceiptInfo> latestReceiptInfo = [];
  
/* An array where each element contains the pending renewal information for each auto-renewable subscription identified in product_id. The contents of this array are identical to those in responseBody.Pending_renewal_info in the verifyReciept endpoint response for receipt validation. */
  List<AppleStorePendingRenewalInfo> pendingRenewalInfo = [];
  
/* The status code, where 0 indicates that the notification is valid. */
  int status = null;
  
  AppleStoreUnifiedReceipt();

  @override
  String toString() {
    return 'AppleStoreUnifiedReceipt[environment=$environment, latestReceipt=$latestReceipt, latestReceiptInfo=$latestReceiptInfo, pendingRenewalInfo=$pendingRenewalInfo, status=$status, ]';
  }

  AppleStoreUnifiedReceipt.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    environment =
        json['environment']
    ;
    latestReceipt =
        json['latest_receipt']
    ;
    latestReceiptInfo =
      AppleStoreLatestReceiptInfo.listFromJson(json['latest_receipt_info'])
;
    pendingRenewalInfo =
      AppleStorePendingRenewalInfo.listFromJson(json['pending_renewal_info'])
;
    status =
        json['status']
    ;
  }

  Map<String, dynamic> toJson() {
    return {
      'environment': environment,
      'latest_receipt': latestReceipt,
      'latest_receipt_info': latestReceiptInfo,
      'pending_renewal_info': pendingRenewalInfo,
      'status': status
     };
  }

  static List<AppleStoreUnifiedReceipt> listFromJson(List<dynamic> json) {
    return json == null ? new List<AppleStoreUnifiedReceipt>() : json.map((value) => new AppleStoreUnifiedReceipt.fromJson(value)).toList();
  }

  static Map<String, AppleStoreUnifiedReceipt> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, AppleStoreUnifiedReceipt>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new AppleStoreUnifiedReceipt.fromJson(value));
    }
    return map;
  }
}

