part of forestvpn_api.api;

class WireguardPeer {
  
  String endpoint = null;
  

  String privateKey = null;
  

  String publicKey = null;
  

  String presharedKey = null;
  

  int persistentKeepalive = null;
  

  List<String> allowedIps = [];
  

  DateTime blockedAt = null;
  
  WireguardPeer();

  @override
  String toString() {
    return 'WireguardPeer[endpoint=$endpoint, privateKey=$privateKey, publicKey=$publicKey, presharedKey=$presharedKey, persistentKeepalive=$persistentKeepalive, allowedIps=$allowedIps, blockedAt=$blockedAt, ]';
  }

  WireguardPeer.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    endpoint =
        json['endpoint']
    ;
    privateKey =
        json['private_key']
    ;
    publicKey =
        json['public_key']
    ;
    presharedKey =
        json['preshared_key']
    ;
    persistentKeepalive =
        json['persistent_keepalive']
    ;
    allowedIps =
        (json['allowed_ips'] as List).map((item) => item as String).toList()
    ;
    blockedAt = json['blocked_at'] == null ? null : DateTime.parse(json['blocked_at']);
  }

  Map<String, dynamic> toJson() {
    return {
      'endpoint': endpoint,
      'private_key': privateKey,
      'public_key': publicKey,
      'preshared_key': presharedKey,
      'persistent_keepalive': persistentKeepalive,
      'allowed_ips': allowedIps,
      'blocked_at': blockedAt == null ? '' : blockedAt.toUtc().toIso8601String()
     };
  }

  static List<WireguardPeer> listFromJson(List<dynamic> json) {
    return json == null ? new List<WireguardPeer>() : json.map((value) => new WireguardPeer.fromJson(value)).toList();
  }

  static Map<String, WireguardPeer> mapFromJson(Map<String, Map<String, dynamic>> json) {
    var map = new Map<String, WireguardPeer>();
    if (json != null && json.length > 0) {
      json.forEach((String key, Map<String, dynamic> value) => map[key] = new WireguardPeer.fromJson(value));
    }
    return map;
  }
}

